/*--------------------------------------------------------------------------+
$Id: IdLabeledPropertySection.java 5274 2012-08-02 07:54:11Z mou $
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.internal.properties;

import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.fortiss.tooling.kernel.model.FortissToolingKernelPackage;
import org.fortiss.tooling.kernel.model.IElementWithURI;
import org.fortiss.tooling.kernel.ui.extension.base.PropertySectionBase;
import org.fortiss.tooling.kernel.ui.util.ObservableUtils;

/**
 * Property section for {@link IElementWithURI}s.
 * 
 * @author ratiu
 * @author $Author: ratiu $
 * @version $Rev: 5274 $
 * @ConQAT.Rating GREEN Hash: E6A4B98E0681984D8DCCBFFBF99412CA
 */
public final class ElementWithURIPropertySection extends PropertySectionBase {

	/** URI edit widget. */
	private Text uriText;

	/** Stores the current input. */
	private IElementWithURI elementWithURI;

	/** {@inheritDoc} */
	@Override
	public void createControls(Composite parent, TabbedPropertySheetPage aTabbedPropertySheetPage) {
		super.createControls(parent, aTabbedPropertySheetPage);
		uriText = createFormText("URI");
		uriText.setEnabled(false);
	}

	/** {@inheritDoc} */
	@Override
	protected void setSectionInput(Object input) {
		if(input instanceof IElementWithURI) {
			elementWithURI = (IElementWithURI)input;
		}
	}

	/** {@inheritDoc} */
	@Override
	public void refresh() {
		super.refresh();

		IObservableValue modelObservable =
				ObservableUtils.observeValue(elementWithURI,
						FortissToolingKernelPackage.Literals.IELEMENT_WITH_URI__URI);
		dbc.bindValue(SWTObservables.observeText(uriText, SWT.FocusOut), modelObservable, null,
				null);
	}
}
